% The example code provided here are for pre-processing of the reconstructed multi-session dMRI
% data that correct for: 
% i)   signal intensity drift across and within sessions; (demo0_intensityNorm_driftCorrection.m)
% ii)  susceptibility and eddy-current induced distortion (demo1_TopupEddy.m);
% iii) gradient non-linearity (demo3_OneStepResampling.m);
% iv)  subject motion (demo2_postEddy for estimation and then demo3_OneStepResampling.m);
% in a one-step resampling process to ensure minimal smoothing due to interpolation.

% demo4_RotatingBvecs.m is to correct for diffusion vectors after motion
% correction;

% The data input of this code should be reconstructed dMRI data without any pre-processing, 
% but here, the reconstructed dMRI data after gradient non-linearity are provided in the folder 'reconDWI_sessionN_subsetM', 
% and are used in the example code instead. This is because the gradient non-linearity coefficients needed in this
% preprocessing process are considered proprietary by Siemens, and therefore not
% made publically available. The users can start from the minimally preprocessed reconstructed data 
% (with only gradient non-linearity correction) and skip the gradient non-linearity correction step in the preprocessing code. 

% The data was preprocessed in MATLAB R2019a (Mathworks, Natick, MA, USA)
% and using FMRIB Software Library (FSL) 6.0.1. 
% The 'load_nifti' and 'save_nifti' are functions of freesurfer 6.0.0.  

% For more information about the code or the data, please contact:
% Fuyixue Wang <fuyixue@mit.edu> or <fuyixue2016@gmail.com>, Aug/2020
