%% Rotating bves

% Fuyixue Wang <fuyixue@mit.edu> or <fuyixue2016@gmail.com>, Aug/2020

clear
close all
%% root directory
dir_tmp = '../tmp/';
fname = ["session1_subset01","session1_subset02","session2_subset03","session2_subset04","session3_subset05","session3_subset06",...
         "session4_subset07","session4_subset08","session5_subset09","session5_subset10","session6_subset11",'session6_subset12',...
         "session7_subset13","session7_subset14","session8_subset15","session8_subset16","session9_subset17",'session9_subset18'];

dir_rotBvec = fullfile(dir_tmp,'resampdata','rotBvecs');
mkdir(dir_rotBvec);

for n = 1:length(fname)
    fpBvecEddy = fullfile(dir_tmp,'eddy',fname{n},[fname{n},'_eddy.eddy_rotated_bvecs']);
    fpAffMat = fullfile(dir_tmp,'postEddy','mov',['AffMat_',fname{n},'.mat']);
    fpLog = fullfile(dir_rotBvec,[fname{n},'.ecclog']);
    fpRotBvec = fullfile(dir_rotBvec,[fname{n},'.eddy_mov_rotated_bvecs']);
    
    % load matrix
    mat = readtxt(fpAffMat);    
    bvec = dlmread(fpBvecEddy);

    % write log files
    log = {};
    for m = 1 : size(bvec, 2)
        logseg = {['processing tmp' num2str(m-1,'%03.f')]};
        logseg = cat(1, logseg, {''}, {'Final result:'}, mat, {''});
        log = cat(1, log, logseg);
    end 
    fid = fopen(fpLog, 'w');
    fprintf(fid, '%s\n', log{:});
    fclose(fid);

    % rotate bvecs
    disp('rotating bvecs ...')
    cmd = ['fdt_rotate_bvecs ',fpBvecEddy,' ',fpRotBvec,' ',fpLog]; % this is the final b-vector file saved in processedDWI_sessionN_subsetM/sessionN_subsetM.bvec
    [status, result] = system(cmd, '-echo');
end

function cell = readtxt(fp)
    fid = fopen(fp, 'r');
    tmp = textscan(fid, '%s', 'delimiter', '\n');
    cell = tmp{1};
    fclose(fid);
end